#pragma once

class audio_device {
public:
    virtual ~audio_device() = default;

    virtual bool init() = 0;
    virtual void destroy() = 0;

    void set_sample_rate(double sample_rate) {
        if (on_set_sample_rate(sample_rate)) {
            sample_rate_ = sample_rate;
        }
    }
    void set_buffer_size(uint32_t buffer_size) {
        if (on_set_buffer_size(buffer_size)) {
            buffer_size_ = buffer_size;
        }
    }

    [[nodiscard]] double sample_rate() const { return sample_rate_; }
    [[nodiscard]] uint32_t buffer_size() const { return buffer_size_; }
protected:
    virtual bool on_set_sample_rate(double in_sample_rate) = 0;
    virtual bool on_set_buffer_size(uint32_t in_buffer_size) = 0;
private:
    double sample_rate_ = 44100;
    uint32_t buffer_size_ = 2048;
};
